/*********************************************************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2020,ɿƼ
 * All rights reserved.
 * QQȺһȺ179029047()  Ⱥ244861897()  Ⱥ824575535
 *
 * ݰȨɿƼУδҵ;
 * ӭλʹò޸ʱ뱣ɿƼİȨ
 *
 * @file       		fifo
 * @company	   		ɶɿƼ޹˾
 * @author     		ɿƼ(QQ790875685)
 * @version    		鿴docversionļ 汾˵
 * @Software 		MDK FOR C251 V5.60
 * @Target core		STC32F12K
 * @Taobao   		https://seekfree.taobao.com/
 * @date       		2020-4-14
 ********************************************************************************************************************/



#ifndef __ZF_FIFO_H
#define __ZF_FIFO_H


typedef enum
{
    FIFO_SUCCESS,                                                               // FIFO ɹ

    FIFO_RESET_UNDO,                                                            // FIFO òδִ
    FIFO_CLEAR_UNDO,                                                            // FIFO ղδִ
    FIFO_BUFFER_NULL,                                                           // FIFO û쳣
    FIFO_WRITE_UNDO,                                                            // FIFO дδִ
    FIFO_SPACE_NO_ENOUGH,                                                       // FIFO д ռ䲻
    FIFO_READ_UNDO,                                                             // FIFO ȡδִ
    FIFO_DATA_NO_ENOUGH,                                                        // FIFO ȡ ݳȲ
}fifo_state_enum;                                                               // FIFO 

// ߼
// ò   ǿ FIFO ʹ
// д   Լдʱ
// ˳ȡ   պòʱ
// βȡ   պԼдʱ
// ȡղ   պԼȡʱ
// Ϊ˷ֹжǶ׵ݻ
typedef enum
{
    FIFO_IDLE       = 0x00,                                                     // ״̬

    FIFO_RESET      = 0x01,                                                     // ִû
    FIFO_CLEAR      = 0x02,                                                     // ִջ
    FIFO_WRITE      = 0x04,                                                     // ִд뻺
    FIFO_READ       = 0x08,                                                     // ִжȡ
}fifo_execution_enum;                                                           // FIFO ״̬ ΪǶʹԤ ޷ȫ

typedef enum
{
    FIFO_READ_AND_CLEAN,                                                        // FIFO ģʽ ȡͷŶӦ
    FIFO_READ_ONLY,                                                             // FIFO ģʽ ȡ
}fifo_operation_enum;

typedef enum
{
    FIFO_DATA_8BIT,                                                             // FIFO λ 8bit
    FIFO_DATA_16BIT,                                                            // FIFO λ 16bit
    FIFO_DATA_32BIT,                                                            // FIFO λ 32bit
}fifo_data_type_enum;

typedef struct 
{
    uint8               execution;                                              // ִв
    fifo_data_type_enum type;                                                   // 
    void                *buffer;                                                // ָ
    uint32              head;                                                   // ͷָ ָյĻ
    uint32              end;                                                    // βָ ָǿջ棨ȫճ⣩
    uint32              reamin_size;                                            // ʣС
    uint32              max;                                                    // ܴС
}fifo_struct;

fifo_state_enum fifo_clear              (fifo_struct *fifo);
uint32          fifo_used               (fifo_struct *fifo);

fifo_state_enum fifo_write_element      (fifo_struct *fifo, uint32 dat);
fifo_state_enum fifo_write_buffer       (fifo_struct *fifo, void *dat, uint32 length);
fifo_state_enum fifo_read_element       (fifo_struct *fifo, void *dat, fifo_operation_enum flag);
fifo_state_enum fifo_read_buffer        (fifo_struct *fifo, void *dat, uint32 *length, fifo_operation_enum flag);
fifo_state_enum fifo_read_tail_buffer   (fifo_struct *fifo, void *dat, uint32 *length, fifo_operation_enum flag);

fifo_state_enum fifo_init               (fifo_struct *fifo, fifo_data_type_enum type, void *buffer_addr, uint32 len);


#endif


