#include "menu.h"

// ˵ϵͳ״̬
static MenuSystem menu_sys;

// CCD˵
const MenuItem ccd_menu[] = {
    {"ֵ߽", MENU_TYPE_PARAM, &car.CCD_left.boundary_left, 0, 128, 1, NULL, NULL},
    {"ұֵ߽", MENU_TYPE_PARAM, &car.CCD_left.boundary_right, 0, 128, 1, NULL, NULL},
    {"λ", MENU_TYPE_PARAM, &car.CCD_left.boundary_middle, 0, 128, 0.1, NULL, NULL},
    {"ֵ", MENU_TYPE_PARAM, &car.CCD_left.RING_WIDTH_TH, 0, 100, 1, NULL, NULL},
    {"", MENU_TYPE_SUBMENU, NULL, 0, 0, 0, NULL, main_menu},
    {NULL}
};

// PID˵
const MenuItem pid_menu[] = {
    {"Kp", MENU_TYPE_PARAM, &car.Low_L.Kp, 0, 10, 0.1, NULL, NULL},
    {"Ki", MENU_TYPE_PARAM, &car.Low_L.Ki, 0, 10, 0.01, NULL, NULL},
    {"Kd", MENU_TYPE_PARAM, &car.Low_L.Kd, 0, 10, 0.1, NULL, NULL},
    {"", MENU_TYPE_SUBMENU, NULL, 0, 0, 0, NULL, main_menu},
    {NULL}
};

// ˵
const MenuItem main_menu[] = {
    {"CCD", MENU_TYPE_SUBMENU, NULL, 0, 0, 0, ccd_menu, NULL},
    {"PID", MENU_TYPE_SUBMENU, NULL, 0, 0, 0, pid_menu, NULL},
    {"", MENU_TYPE_ROOT, NULL, 0, 0, 0, NULL, NULL},
    {NULL}
};

// ʼ˵ϵͳ
void Menu_Init(void) {
    menu_sys.current_menu = main_menu;
    menu_sys.current_item = main_menu;
    menu_sys.item_index = 0;
    menu_sys.edit_mode = 0;
    OLED_Clear();
}

// 
void Menu_ProcessKey(uint8_t key) {
    if (menu_sys.edit_mode) {
        // ༭ģʽ
        float* param = (float*)menu_sys.current_item->data;
        if (key & KEY_INC) {
            *param += menu_sys.current_item->step;
            if (*param > menu_sys.current_item->max_val)
                *param = menu_sys.current_item->max_val;
        }
        if (key & KEY_DEC) {
            *param -= menu_sys.current_item->step;
            if (*param < menu_sys.current_item->min_val)
                *param = menu_sys.current_item->min_val;
        }
        if (key & KEY_ENTER) {
            menu_sys.edit_mode = 0;
        }
    } else {
        // ģʽ
        if (key & KEY_NEXT) {
            menu_sys.item_index++;
            if (menu_sys.current_menu[menu_sys.item_index].text == NULL)
                menu_sys.item_index = 0;
            menu_sys.current_item = &menu_sys.current_menu[menu_sys.item_index];
        }
        if (key & KEY_ENTER) {
            if (menu_sys.current_item->type == MENU_TYPE_SUBMENU) {
                menu_sys.current_menu = menu_sys.current_item->child;
                menu_sys.current_item = menu_sys.current_menu;
                menu_sys.item_index = 0;
            } else if (menu_sys.current_item->type == MENU_TYPE_PARAM) {
                menu_sys.edit_mode = 1;
            }
        }
    }
    Menu_RefreshDisplay();
}

// ˢOLEDʾ
void Menu_RefreshDisplay(void) {
    OLED_Clear();
    MyOLED_Set_Pos(0, 0);
    
    // ʾǰ˵
    OLED_ShowString(0, 0, (char*)menu_sys.current_menu[0].text, 8);
    
    // ʾǰѡ
    for (uint8_t i = 0; i < 3; i++) {
        if (menu_sys.current_menu[i].text == NULL) break;
        
        MyOLED_Set_Pos(0, (i+1)*2);
        if (i == menu_sys.item_index) {
            OLED_ShowString(0, (i+1)*2, ">", 8);
        }
        OLED_ShowString(8, (i+1)*2, (char*)menu_sys.current_menu[i].text, 8);
        
        // ǲʾǰֵ
        if (menu_sys.current_menu[i].type == MENU_TYPE_PARAM) {
            char buf[16];
            float val = *(float*)menu_sys.current_menu[i].data;
            sprintf(buf, ":%.2f", val);
            OLED_ShowString(64, (i+1)*2, buf, 8);
        }
    }
    
    // ༭ģʽʾ
    if (menu_sys.edit_mode) {
        OLED_ShowString(100, 6, "EDIT", 8);
    }
}