#ifndef __MENU_H__
#define __MENU_H__

#include "iic_oled.h"
#include "car.h"

// 
#define KEY_ENTER 0x01  // P01˵
#define KEY_NEXT  0x02  // P02лѡ
#define KEY_INC   0x04  // P03ֵ
#define KEY_DEC   0x08  // P04ֵ

// ˵
typedef enum {
    MENU_TYPE_ROOT,     // ˵
    MENU_TYPE_SUBMENU,  // Ӳ˵
    MENU_TYPE_PARAM,    // 
    MENU_TYPE_INFO      // Ϣʾ
} MenuItemType;

// ˵ṹ
typedef struct MenuItem {
    const char* text;           // ʾı
    MenuItemType type;          // ˵
    void* data;                 // ָ
    float min_val, max_val;     // Χ(ǲ)
    float step;                 // 
    const struct MenuItem* child; // Ӳ˵
    const struct MenuItem* parent; // ˵
} MenuItem;

// ˵ϵͳ״̬
typedef struct {
    const MenuItem* current_menu;  // ǰ˵
    const MenuItem* current_item;  // ǰѡ
    uint8 item_index;           // ǰѡ
    uint8 edit_mode;            // ༭ģʽ־
} MenuSystem;

// 
void Menu_Init(void);
void Menu_ProcessKey(uint8_t key);
void Menu_RefreshDisplay(void);

// CCD˵
extern const MenuItem ccd_menu[];
// PID˵
extern const MenuItem pid_menu[];
// ˵
extern const MenuItem main_menu[];

#endif