#include "headfile.h"
#include "iic_oled.h"
#include "strategy.h"
#include "oled.h"
#include "car.h"

#define UNLOCK_Sta 1 //1-->can change; 0--->cant change!!		

float *ASAD1=NULL;
float *ASAD2=NULL;
float *ASAD3=NULL;

		
typedef enum {
    MEUN_1,   
    MEUN_2,    
    MEUN_3,
		MEUN_4,
} screen_t;

typedef enum {
    PARAM_1,     
    PARAM_2,
		PARAM_3,	
} param_t;

typedef struct {
    screen_t current_screen;  // ǰ
    param_t current_param;    // ǰ
} system_state_t;

system_state_t sys_state = {
    MEUN_1,
    PARAM_1,
};

void process_buttons(void) {
    // B1 - л
    if(P01 == 0)
		{	 	
			delay_ms(50); // 
			if (P01 == 0)
				{
					sys_state.current_screen = (sys_state.current_screen + 1) % 4;
					OLED_Clear();
	/***************************************************************************/			
						if(UNLOCK_Sta){
								if(sys_state.current_screen==0)
								{
									ASAD1=&car.Speed_L.Kp;
									ASAD2=&car.Speed_L.Ki;
									ASAD3=&car.Speed_L.Kd;
								}
							else if(sys_state.current_screen==1)
								{
									ASAD1=&car.Speed_R.Kp;
									ASAD2=&car.Speed_R.Ki;
									ASAD3=&car.Speed_R.Kd;			
								}
							else if(sys_state.current_screen==2)
								{
									ASAD1=&car.Low_L.Kp;
									ASAD2=&car.Low_L.Ki;
									ASAD3=&car.Low_L.Kd;			
								}
							else if(sys_state.current_screen==3)
								{
									ASAD1=&car.Low_R.Kp;
									ASAD2=&car.Low_R.Ki;
									ASAD3=&car.Low_R.Kd;			
								}
						}							
	/****************************************************************************/							
					sys_state.current_param = PARAM_1; // Ĭ
			}
    }
    
    // B2
    if(P02 == 0) 
		{		
			delay_ms(50);
			if(P02 == 0) {
				sys_state.current_param = (sys_state.current_param + 1) % 3;// : л				
				}
    }
		// B3 //
		if(P03 == 0&&UNLOCK_Sta) 
		{
			delay_ms(50);
			if(P03 == 0) 
			{			
				switch (sys_state.current_param)
				{
					case PARAM_1:         
						*ASAD1-=0.01;
						break;
					case PARAM_2:         
						*ASAD2-=0.01;
						break;	
					case PARAM_3:         
						*ASAD3-=0.01;
						break;
					default:   
						break;
				 }
			}
    }
		
		// B4
		if(P04 == 0&&UNLOCK_Sta) 
		{	
			delay_ms(50);
			if(P04 == 0) 
			{
				switch (sys_state.current_param)
				{
				case PARAM_1:         
						*ASAD1+=0.01;
						break;
				case PARAM_2:         
						*ASAD2+=0.01;
						break;	
				case PARAM_3:         
						*ASAD3+=0.01;
						break;
				default:   
						break;
				}
			}	
    }		
}

void Draw_Menu_PID(void) { // PID 
	char buff[8];
	switch (sys_state.current_screen){
		case MEUN_1:
			sprintf(buff, "SPEED_L");
			OLED_ShowString(1,0,(uint8 *)buff,16);
			sprintf(buff, "kp=%.2f",car.Speed_L.Kp);
			OLED_ShowString(1,2,(uint8 *)buff,16);
			sprintf(buff, "ki=%.2f",car.Speed_L.Ki);
			OLED_ShowString(1,4,(uint8 *)buff,16);
			sprintf(buff, "op=%.2f",car.Speed_L.output);
			OLED_ShowString(1,6,(uint8 *)buff,16);	
		break;
		case MEUN_2:
			sprintf(buff, "SPEED_R");
			OLED_ShowString(1,0,(uint8 *)buff,16);
			sprintf(buff, "kp=%.2f",car.Speed_R.Kp);
			OLED_ShowString(1,2,(uint8 *)buff,16);
			sprintf(buff, "ki=%.2f",car.Speed_R.Ki);
			OLED_ShowString(1,4,(uint8 *)buff,16);
			sprintf(buff, "op=%.2f",car.Speed_R.output);
			OLED_ShowString(1,6,(uint8 *)buff,16);	
		break;
		case MEUN_3:
			sprintf(buff, "Low_L");
			OLED_ShowString(1,0,(uint8 *)buff,16);
			sprintf(buff, "kp=%.2f",car.Low_L.Kp);
			OLED_ShowString(1,2,(uint8 *)buff,16);
			sprintf(buff, "ki=%.2f",car.Low_L.Ki);
			OLED_ShowString(1,4,(uint8 *)buff,16);
			sprintf(buff, "kd=%.2f",car.Low_L.Kd);
			OLED_ShowString(1,6,(uint8 *)buff,16);	
		break;
		case MEUN_4:
			sprintf(buff, "Low_R");
			OLED_ShowString(1,0,(uint8 *)buff,16);
			sprintf(buff, "kp=%.2f",car.Low_R.Kp);
			OLED_ShowString(1,2,(uint8 *)buff,16);
			sprintf(buff, "ki=%.2f",car.Low_R.Ki);
			OLED_ShowString(1,4,(uint8 *)buff,16);
			sprintf(buff, "kd=%.2f",car.Low_R.Kd);
			OLED_ShowString(1,6,(uint8 *)buff,16);	
		break;	
	}	
}


void Draw_Menu_CCD(void) { 
	char buff[6];
	switch (sys_state.current_screen){
		case MEUN_1:
			sprintf(buff, "CCD_L");
			OLED_ShowString(1,0,(uint8 *)buff,16);
			sprintf(buff, "BLeft=%d",car.CCD_left.boundary_left);
			OLED_ShowString(1,2,(uint8 *)buff,16);
			sprintf(buff, "BRight=%d",car.CCD_left.boundary_right);
			OLED_ShowString(1,4,(uint8 *)buff,16);
			sprintf(buff, "BMid=%d",car.CCD_left.boundary_middle);
			OLED_ShowString(1,6,(uint8 *)buff,16);	
		break;
		case MEUN_2:
			sprintf(buff, "CCD_C");
			OLED_ShowString(1,0,(uint8 *)buff,16);
			sprintf(buff, "BLeft=%d",car.CCD_center.boundary_left);
			OLED_ShowString(1,2,(uint8 *)buff,16);
			sprintf(buff, "BRight=%d",car.CCD_center.boundary_right);
			OLED_ShowString(1,4,(uint8 *)buff,16);
			sprintf(buff, "BMid=%d",car.CCD_center.boundary_middle);
			OLED_ShowString(1,6,(uint8 *)buff,16);	
		break;
		case MEUN_3:
			sprintf(buff, "CCD_R");
			OLED_ShowString(1,0,(uint8 *)buff,16);
			sprintf(buff, "BLeft=%d",car.CCD_right.boundary_left);
			OLED_ShowString(1,2,(uint8 *)buff,16);
			sprintf(buff, "BRight=%d",car.CCD_right.boundary_right);
			OLED_ShowString(1,4,(uint8 *)buff,16);
			sprintf(buff, "BMid=%d",car.CCD_right.boundary_middle);
			OLED_ShowString(1,6,(uint8 *)buff,16);	
		break;
		case MEUN_4:
			sprintf(buff, "RW");
			OLED_ShowString(1,0,(uint8 *)buff,16);
			sprintf(buff, "L=%d",car.CCD_left.RING_WIDTH_TH);
			OLED_ShowString(1,2,(uint8 *)buff,16);
			sprintf(buff, "C=%d",car.CCD_center.RING_WIDTH_TH);
			OLED_ShowString(1,4,(uint8 *)buff,16);
			sprintf(buff, "M=%d",car.CCD_right.RING_WIDTH_TH);
			OLED_ShowString(1,6,(uint8 *)buff,16);	
		break;	
	}	
}


